<?php
/*
 * Uniguerre - Version 1.0
 *				
 */
/******************************************************************************/
/* Role du fichier:
/*		-- Calcul en fonction de la rsistance des dfenses et de la puissance 
/*			des MIPs de l'attaquant des pertes sur la plante cible
/*		-- Envoi d'un message au deux participants de l'attaque MIP
/******************************************************************************/
/* Liste de la dfense existante sur Uniguerre
/* 		401 => 'Lanceur de missiles',
/* 		402 => 'Artillerie laser lgre',
/* 		403 => 'Artillerie laser lourde',
/* 		404 => 'Canon de Gauss',
/* 		405 => 'Artillerie &agrave; ions',
/* 		406 => 'Lanceur de plasma',
/* 		407 => 'Petit bouclier',
/* 		408 => 'Grand bouclier',
/* 		409 => 'Protecteur plantaire',
/* 		410 => 'Bloqueur'
/******************************************************************************/

function MipAttack ($NbreMip, $IDAversaire, $Prioritaire) {
	global $lang, $user, $planetrow;

    $InfoAdversaire = doquery("SELECT * FROM {{table}} WHERE `id`='" . $IDAversaire . "'", "planets", true);
	$PuissanceAttaque = ($NbreMip * 300) * (1.05 * $user['military_tech']);
	
    $TableauDeDefense = array(
		401 => array ('shield' => 20),
        402 => array ('shield' => 75),
        403 => array ('shield' => 150),
        404 => array ('shield' => 500),
        405 => array ('shield' => 200),
        406 => array ('shield' => 3000),
        407 => array ('shield' => 1),
        408 => array ('shield' => 1),
		409 => array ('shield' => 1),
		410 => array ('shield' => 10000)
    );

    $DefenseAdversaire = array(
		401 => ($InfoAdversaire['misil_launcher']),
        402 => ($InfoAdversaire['small_laser']),
        403 => ($InfoAdversaire['big_laser']),
        404 => ($InfoAdversaire['gauss_canyon']),
        405 => ($InfoAdversaire['ionic_canyon']),
        406 => ($InfoAdversaire['buster_canyon']),
        407 => ($InfoAdversaire['small_protection_shield']),
        408 => ($InfoAdversaire['big_protection_shield']),
		409 => ($InfoAdversaire['planet_protector']),
		410 => ($InfoAdversaire['bloqueur'])
	);
	
	if ($DefenseAdversaire[$Prioritaire] > 0 AND $Prioritaire != 400)
	{
		$Degats_Multiplicateur = 1.5;
		$Perte[$Prioritaire] = round(($PuissanceAttaque / $TableauDeDefense[$Prioritaire]['shield']) * $Degats_Multiplicateur);
		if ($Perte[$Prioritaire] > $DefenseAdversaire[$Prioritaire]) $Perte[$Prioritaire] = $DefenseAdversaire[$Prioritaire];

		$PuissanceAttaque = ($PuissanceAttaque - $Perte[$Prioritaire]);
	}

	$round = 0;
	$PerteDefense = array();
	do {
		for ( $i=401 ; $i<=410 ; $i++)
		{
			if ($PuissanceAttaque > 0)
			{

				if ($DefenseAdversaire[$i] > 0) 
				{
					
					if ($i != 407 AND $i != 408 AND $i!= 409)
					{
						$PerteDef[$i] = round($PuissanceAttaque / $TableauDeDefense[$i]['shield']);
						
						if ($i == $Prioritaire) {
							$PerteDefense[$i] = $PerteDef[$i] + $Perte[$Prioritaire];	
						}else{
							$PerteDefense[$i] = $PerteDef[$i];
						}
						
						if ($PerteDefense[$i] > $DefenseAdversaire[$i]) $PerteDefense[$i] = $DefenseAdversaire[$i];
						$PuissanceAttaque = $PuissanceAttaque - $PerteDefense[$i];
						$DefenseAdversaire[$i] = $DefenseAdversaire[$i] - $PerteDefense[$i];
					}
				}
			}
			
		}

		$round++;
	}while($PuissanceAttaque < 200 AND $round <= 20);
	
	
	$mess = "\n";
	for ($j=401;$j<=410; $j++) 
	{
		if ($PerteDefense[$j] > 0)
		{
			if ($j != 407 AND $j != 408 AND $j!= 409) {
				$mess .= pretty_number($PerteDefense[$j])." ".$lang['tech'][$j].", \n";
			}
		}
	}
	$mess .= "Plus aucun boucliers.";
	
	//MAJ de la dfense perdu
		$SqlDefenseur = "UPDATE {{table}} SET ";
		$SqlDefenseur .= "`misil_launcher`='".$DefenseAdversaire[401]."', ";
		$SqlDefenseur .= "`small_laser`='".$DefenseAdversaire[402]."', ";
		$SqlDefenseur .= "`big_laser`='".$DefenseAdversaire[403]."', ";
		$SqlDefenseur .= "`gauss_canyon`='".$DefenseAdversaire[404]."', ";
		$SqlDefenseur .= "`ionic_canyon`='".$DefenseAdversaire[405]."', ";
		$SqlDefenseur .= "`buster_canyon`='".$DefenseAdversaire[406]."', ";
		$SqlDefenseur .= "`small_protection_shield`='0', ";
		$SqlDefenseur .= "`big_protection_shield`='0', ";
		$SqlDefenseur .= "`planet_protector`='0', ";
		$SqlDefenseur .= "`bloqueur`='".$DefenseAdversaire[410]."' ";
		$SqlDefenseur .= " WHERE `id`='".$IDAversaire."'";
		doquery($SqlDefenseur, 'planets');
	
	//MAJ de l'attaquant (missiles)
		doquery("UPDATE {{table}} SET `interplanetary_misil` = '".($planetrow['interplanetary_misil']-$NbreMip)."' WHERE `id`='" . $planetrow['id'] . "'", "planets");
	
    // Message a l'attaquant
		$Owner    = $user['id'];
		$Sender   = "0";
		$Time     = time();
		$Type     = 3;
		$From     = "Quartier G&eacute;n&eacute;ral";
		$Subject  = "Rapport d'attaque par MIP";
		$Message  = "Vous avez touch&eacute la d&eacute;fense avec vos MIPs. Les d&eacute;gats sont de: \n".$mess;
		SendSimpleMessage($Owner, $Sender, $Time, $Type, $From, $Subject, $Message);

    // Message a l'attaqu
		$Message2  = "Votre d&eacute;fense a &eacute;t&eacute; touch&eacute; suit &agrave; l'impact de MIPs. Les d&eacute;gats sont de: \n".$mess;
		SendSimpleMessage($InfoAdversaire['id_owner'], $Sender, $Time, $Type, $From, $Subject, $Message2);

}

?>